#pragma once

#include "common.h"
#include "mcmc.h"
#include "DispPost.h"

using namespace cmmn;
using namespace ns_mcmc;
using namespace Threading;


namespace OmegaMCMC {

	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;

	/// <summary>
	/// Form1 ̊Tv
	///
	/// x: ̃NX̖OύXꍇÃNXˑ邷ׂĂ .resx t@CɊ֘Atꂽ
	///          }l[W \[X RpC c[ɑ΂ 'Resource File Name' vpeB
	///          ύXKv܂B̕ύXsȂƁA
	///          fUCiƁÃtH[Ɋ֘Atꂽ[JCYς݃\[XƂA
	///          ݂ɗpłȂȂ܂B
	/// </summary>
	public ref class Form1 : public System::Windows::Forms::Form
	{
	public:
		Form1(void)
		{
			InitializeComponent();
			//
			//TODO: ɃRXgN^ R[hǉ܂
			//
		}

	protected:
		/// <summary>
		/// gp̃\[XׂăN[Abv܂B
		/// </summary>
		~Form1()
		{
			if (components)
			{
				delete components;
			}
		}
	private: System::Windows::Forms::Button^  buttonGO;
	protected: 
	private: System::Windows::Forms::Button^  buttonClose;
	private: System::Windows::Forms::OpenFileDialog^  openFileDialog1;
	private: System::Windows::Forms::SaveFileDialog^  saveFileDialog1;
	private: System::Windows::Forms::Label^  label1;
	private: System::Windows::Forms::CheckBox^  checkBox1;

	private:
		/// <summary>
		/// KvȃfUCiϐłB
		/// </summary>
		System::ComponentModel::Container ^components;

#pragma region Windows Form Designer generated code
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		void InitializeComponent(void)
		{
			this->buttonGO = (gcnew System::Windows::Forms::Button());
			this->buttonClose = (gcnew System::Windows::Forms::Button());
			this->openFileDialog1 = (gcnew System::Windows::Forms::OpenFileDialog());
			this->saveFileDialog1 = (gcnew System::Windows::Forms::SaveFileDialog());
			this->label1 = (gcnew System::Windows::Forms::Label());
			this->checkBox1 = (gcnew System::Windows::Forms::CheckBox());
			this->SuspendLayout();
			// 
			// buttonGO
			// 
			this->buttonGO->Location = System::Drawing::Point(47, 141);
			this->buttonGO->Name = L"buttonGO";
			this->buttonGO->Size = System::Drawing::Size(75, 23);
			this->buttonGO->TabIndex = 0;
			this->buttonGO->Text = L"GO";
			this->buttonGO->UseVisualStyleBackColor = true;
			this->buttonGO->Click += gcnew System::EventHandler(this, &Form1::buttonGO_Click);
			// 
			// buttonClose
			// 
			this->buttonClose->Location = System::Drawing::Point(163, 141);
			this->buttonClose->Name = L"buttonClose";
			this->buttonClose->Size = System::Drawing::Size(75, 23);
			this->buttonClose->TabIndex = 1;
			this->buttonClose->Text = L"Close";
			this->buttonClose->UseVisualStyleBackColor = true;
			this->buttonClose->Click += gcnew System::EventHandler(this, &Form1::buttonClose_Click);
			// 
			// openFileDialog1
			// 
			this->openFileDialog1->FileName = L"openFileDialog1";
			// 
			// label1
			// 
			this->label1->AutoSize = true;
			this->label1->Font = (gcnew System::Drawing::Font(L"MS UI Gothic", 12, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(128)));
			this->label1->Location = System::Drawing::Point(44, 65);
			this->label1->Name = L"label1";
			this->label1->Size = System::Drawing::Size(194, 16);
			this->label1->TabIndex = 2;
			this->label1->Text = L"GO{^NbNĉB";
			// 
			// checkBox1
			// 
			this->checkBox1->AutoSize = true;
			this->checkBox1->Location = System::Drawing::Point(95, 210);
			this->checkBox1->Name = L"checkBox1";
			this->checkBox1->Size = System::Drawing::Size(76, 16);
			this->checkBox1->TabIndex = 3;
			this->checkBox1->Text = L"Print Data";
			this->checkBox1->UseVisualStyleBackColor = true;
			// 
			// Form1
			// 
			this->AutoScaleDimensions = System::Drawing::SizeF(6, 12);
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
			this->ClientSize = System::Drawing::Size(284, 263);
			this->Controls->Add(this->checkBox1);
			this->Controls->Add(this->label1);
			this->Controls->Add(this->buttonClose);
			this->Controls->Add(this->buttonGO);
			this->Name = L"Form1";
			this->Text = L"Y. Okamoto, 2012.05";
			this->FormClosing += gcnew System::Windows::Forms::FormClosingEventHandler(this, &Form1::Form1_FormClosing);
			this->ResumeLayout(false);
			this->PerformLayout();

		}
#pragma endregion
	//
	//		pos Ԗڂ̎̕o
	//
	String ^ SeekStr( String ^ str, int pos ){
		String ^ vstr = "";
		array<wchar_t> ^ separator = { ' ', '\t', ',','@','/' };
		array<String ^> ^ ary_str;
		ary_str = str->Split( separator );
		int L = ary_str->Length;
		int ckp = -1;
		int tmpPos = 0;
		do {
			if (ary_str[tmpPos]->Length > 0) ckp++;
			tmpPos++;
		} while ((ckp != pos) && (tmpPos < L) );
		if (ckp == pos) vstr = ary_str[tmpPos-1];

		return vstr;
	}

	double sqr( double v ){
			return  v * v;
	}


	double scale_sgm( double acpt_r ){
		double v = 1.0;
	
		if (acpt_r > 0.5){
			v = 1.0 + 9.0 * (acpt_r - 0.5) / 0.5;
		} else if (acpt_r < 0.3){
			v = 1.0 / (1.0 + 9.0 * (0.3 - acpt_r) / 0.3);
		}

		return v;
	}


	 System::IO::StreamWriter ^ fout;


	private: System::Void buttonClose_Click(System::Object^  sender, System::EventArgs^  e) {
				 Close();
			 }
	private: System::Void buttonGO_Click(System::Object^  sender, System::EventArgs^  e) {
				 openFileDialog1->Filter = "Text File (*.txt)|*.txt";
				 openFileDialog1->Title = "̓f[^t@CH";
				 if (openFileDialog1->ShowDialog() == System::Windows::Forms::DialogResult::Cancel) return;
				 saveFileDialog1->Filter = "Text File (*.txt)|*.txt";
				 saveFileDialog1->Title = "o̓t@CH";
				 if (saveFileDialog1->ShowDialog() == System::Windows::Forms::DialogResult::Cancel) return;
				 buttonGO->Enabled = false;

				 buttonClose->Enabled = false;

				 using System::IO::StreamReader;
				 StreamReader ^ fin = gcnew StreamReader(openFileDialog1->FileName, System::Text::Encoding::GetEncoding("shift-jis"));
				 fout = gcnew StreamWriter(saveFileDialog1->FileName, false, System::Text::Encoding::GetEncoding("shift-jis"));

				 label1->Text = "f[^ǂݍ݂܂B";
				 Update();
				 Application::DoEvents();

				 fout->WriteLine("Data File = " + openFileDialog1->FileName);
				 fout->WriteLine();
				 String ^ s;
				 while (true) {
					 s = fin->ReadLine();
					 if (s->Length > 0)
						 if (s[0] == '/')	break;
				 }
				 s = fin->ReadLine();
				 int NVars = int::Parse(s);
				 s = fin->ReadLine();
				 array<String ^> ^ varLabels;
				 varLabels = gcnew array<String ^>(NVars);
				 for (int i = 0; i < NVars; i++)
					 varLabels[i] = SeekStr(s, i+1);

				 while (true) {
					 s = fin->ReadLine();
					 if (s->Length > 0)
						 if (s[0] == '/')	break;
				 }
				 s = fin->ReadLine();
				 int * selVars;
				 selVars = new int[NVars];
				 for (int i = 0; i < NVars; i++)
					 selVars[i] = int::Parse(SeekStr(s, i));

				 fout->WriteLine("Variable Labels...");
				 for (int i = 0; i < NVars; i++)
					 fout->Write((varLabels[i] + "(" + selVars[i].ToString() + ")")->PadLeft(15));
				 fout->WriteLine();

				 while (true) {
					 s = fin->ReadLine();
					 if (s->Length > 0)
						 if (s[0] == '/')	break;
				 }
				 int NCases = 0;
				 while(true){
					 s = fin->ReadLine();
					 if (s->Length > 0)
						 if (s[0] == '/')
							 break;
					 NCases++;
				 }
				 fin->Close();
				 fout->WriteLine("NVars = " + NVars.ToString() + "     NCases = " + NCases.ToString());

				 double ** data;
				 data = new double*[NVars];
				 for (int i = 0; i < NVars; i++)
					 data[i] = new double[NCases];
				 array<String^> ^IDs;
				 IDs = gcnew array<String^>(NCases);

				 fin = gcnew StreamReader(openFileDialog1->FileName, System::Text::Encoding::GetEncoding("shift-jis"));
				 for (int i = 0; i < 3; i++){
					 while (true) {
						 s = fin->ReadLine();
						 if (s->Length > 0)
							 if (s[0] == '/')	break;
					 }
				 }
				 for (int i = 0; i < NCases; i++){
					 s = fin->ReadLine();
					 IDs[i] = SeekStr(s, 0);
					 for (int j = 0; j < NVars; j++)
						 data[j][i] = double::Parse(SeekStr(s, j+1));
				 }
				 if (checkBox1->Checked){
					 fout->WriteLine();
					 fout->WriteLine("Data...");
					 fout->Write(String("ID").PadRight(10));
					 for (int i = 0; i < NVars; i++)
						 fout->Write(varLabels[i]->PadLeft(10));
					 fout->WriteLine();
					 for (int i = 0; i < NCases; i++){
						 fout->Write(IDs[i]->PadRight(10));
						 for (int j = 0; j < NVars; j++)
							 fout->Write(data[j][i].ToString()->PadLeft(10));
						 fout->WriteLine();
					 }
				 }
				 fin->Close();

				 int M;								//			M = the number of the selected itmes.
				 for (int i = 0; i < NCases; i++){
					M = 0;
					for (int j = 0; j < NVars; j++)
						if (selVars[j] == 1){
							data[M++][i] = data[j][i];
						}
				 }
				 fout->WriteLine();
				 fout->WriteLine("M = " + M.ToString());
				 if (checkBox1->Checked){
					 fout->WriteLine();
					 fout->WriteLine("Data Selected...");
					 fout->Write(String("ID").PadRight(10));
					 for (int i = 0; i < NVars; i++)
						 if (selVars[i] == 1)
							 fout->Write(varLabels[i]->PadLeft(10));
					 fout->WriteLine();
					 for (int i = 0; i < NCases; i++){
						 fout->Write(IDs[i]->PadRight(10));
						 for (int j = 0; j < M; j++)
							 fout->Write(data[j][i].ToString()->PadLeft(10));
						 fout->WriteLine();
					 }
				 }

				 int MM = 0;
				 for (int j = 0; j < NVars; j++)
					 if (selVars[j] == 1)
						 varLabels[MM++] = varLabels[j];
				 fout->WriteLine();
				 fout->WriteLine("Vars Selected...");
				 for (int i = 0; i < MM; i++)
						 fout->Write(varLabels[i]->PadLeft(10));
				 fout->WriteLine();


				 label1->Text = "I am calculating...";
				 this->Update();
				 Application::DoEvents();

				 double * mu0 = new double[M], * lmbd0 = new double[M], * T0 = new double[NCases], * sgmE0 = new double[M],
					 * sgmMu0 = new double[M], * sgmLmbd0 = new double[M], * sgmT0 = new double[NCases], * sgm_sgmE0 = new double[M];
				 double sum_s, sum_ss, v_sd;
				 double * r_acpt_mu = new double[M], * r_acpt_lmbd = new double[M], * r_acpt_T = new double[NCases], * r_acpt_sgmE = new double[M];

				 double * sum = new double[M];
				 for (int i = 0; i < M; i++)
					 sum[i] = 0.0;
				 for (int i = 0; i < NCases; i++){
					for (int j = 0; j < M; j++)
						sum[j] += data[j][i];
				 }
				 double * mean = new double[M];
				 for (int j = 0; j < M; j++)
					mean[j] = sum[j] / double(NCases);
				 for (int j = 0; j < M; j++)
					 mu0[j] = mean[j];
				 sum_s = sum_ss = 0.0;
				 for (int j = 0; j < M; j++){
					sum_s += mu0[j];
					sum_ss += sqr(mu0[j]);
				 }
				 v_sd = Math::Sqrt( (sum_ss - sqr(sum_s) / M) / M );
				 for (int j = 0; j < M; j++)
					 sgmMu0[j] = v_sd;

				 for (int i = 0; i < NCases; i++){
					T0[i] = 0.0;
					sgmT0[i] = v_sd;
				 }
			
				 double ** sjk = new double*[M];
				 for (int j = 0; j < M; j++){
					sjk[j] = new double[M];
					for (int k = 0; k < M; k++)
						sjk[j][k] = 0.0;
				 }
				 for (int i = 0; i < NCases; i++){
					for (int j = 0; j < M; j++)
						for (int k = 0; k < M; k++)
							sjk[j][k] += (data[j][i] - mean[j]) * (data[k][i] - mean[k]);
				 }
				 for (int j = 0; j < M; j++)
					 for (int k = 0; k < M; k++)
						 sjk[j][k] /= (NCases - 1.0);

				 double ssY = 0.0;
				 for (int j = 0; j < M; j++)
					 for (int k = 0; k < M; k++)
						 ssY += sjk[j][k];

				 double sum_sjj = 0.0;
				 for (int j = 0; j < M; j++)
					 sum_sjj += sjk[j][j];

				 double GC_alpha = (double(M) / (M - 1.0)) * (1.0 - sum_sjj / ssY);
				 fout->WriteLine();
				 fout->WriteLine("GC-Alpha = " + GC_alpha.ToString("F5"));

				 double omega_a, omega_b, * lambda = new double[M], GFI, * psi2 = new double[M];

				 CalcOmega_ab( omega_a, omega_b, sjk, M, lambda, GFI, psi2, fout );

				 for (int j = 0; j < M; j++){
					 lmbd0[j] = lambda[j];
					 if(psi2[j] > 0.0){
						sgmE0[j] = Math::Sqrt(psi2[j]);
					 }else{
						sgmE0[j] = 0.01;
					 }
				 }
				 sum_s = sum_ss = 0.0;
				 for (int j = 0; j < M; j++){
					sum_s += lmbd0[j];
					sum_ss += sqr(lmbd0[j]);
				 }
				 v_sd = Math::Sqrt( (sum_ss - sqr(sum_s) / M) / M );
				 for (int j = 0; j < M; j++)
					 sgmLmbd0[j] = v_sd;
				 
				 sum_s = sum_ss = 0.0;
				 for (int j = 0; j < M; j++){
					sum_s += sgmE0[j];
					sum_ss += sqr(sgmE0[j]);
				 }
				 v_sd = Math::Sqrt( (sum_ss - sqr(sum_s) / M) / M );
				 for (int j = 0; j < M; j++)
					 sgm_sgmE0[j] = v_sd;

				 fout->WriteLine();
				 for (int i = 0; i < M; i++)
					 fout->WriteLine(varLabels[i]->PadLeft(15) + ": lambda[" + i.ToString() + "] = " + lambda[i].ToString("F5"));
				 fout->WriteLine();
				 fout->WriteLine("GFI = " + GFI.ToString("F5"));
				 fout->WriteLine();
				 fout->WriteLine("Omega_a = " + omega_a.ToString("F5"));
				 fout->WriteLine("Omega_b = " + omega_b.ToString("F5"));


				 /*************************************************************

										MCMC

				 **************************************************************/

				 int nmcmc = 1;
				 int NSimu = 10000;

				 for (int irep = 0; irep < 5; irep++){
						 MCMC ^ mcmc = gcnew MCMC();
						 mcmc->msg = "Adjusting MCMC; irep = " + irep.ToString() + "/5" + "... ";
						 mcmc->Init( nmcmc, 0, M, NCases, NSimu, data );

						 for (int j = 0; j < M; j++){
							 mcmc->mu[0][j] = mu0[j];
							 mcmc->lmbd[0][j] = lmbd0[j];
							 mcmc->sgmE[0][j] = sgmE0[j];
							 mcmc->sgmMu[j] = sgmMu0[j];
							 mcmc->sgmLmbd[j] = sgmLmbd0[j];
							 mcmc->sgm_sgmE[j] = sgm_sgmE0[j];
						 }
						 for (int i = 0; i < NCases; i++){
							 mcmc->T[0][i] = T0[i];
							 mcmc->sgmT[i] = sgmT0[i];
						 }

						 mcmc->do_mcmc();

						 for (int j = 0; j < M; j++){
							 r_acpt_mu[j] = mcmc->acpt_mu[j] / double(NSimu);
							 r_acpt_lmbd[j] = mcmc->acpt_lmbd[j] / double(NSimu);
							 r_acpt_sgmE[j] = mcmc->acpt_sgmE[j] / double(NSimu);
						 }
						 for (int i = 0; i < NCases; i++)
							 r_acpt_T[i] = mcmc->acpt_T[i] / double(NSimu);

						 for (int j = 0; j < M; j++){
							double sum_mu = 0.0, sum_lmbd = 0.0, sum_sgmE = 0.0;
							for (int i = 0; i < NSimu; i++){
								sum_mu += mcmc->mu[i+1][j];
								sum_lmbd += mcmc->lmbd[i+1][j];
								sum_sgmE += mcmc->sgmE[i+1][j];
							}
							mu0[j] = sum_mu / NSimu;
							lmbd0[j] = sum_lmbd / NSimu;
							sgmE0[j] = sum_sgmE / NSimu;
						 }
						 for (int i = 0; i < NCases; i++){
							double sum = 0.0;
							for (int k = 0; k < NSimu; k++)
								sum += mcmc->T[k+1][i];
							T0[i] = sum / NSimu;
						 }
						 for (int j = 0; j < M; j++){
							sgmMu0[j] *= scale_sgm( r_acpt_mu[j] );
							sgmLmbd0[j] *= scale_sgm( r_acpt_lmbd[j] );
							sgm_sgmE0[j] *= scale_sgm( r_acpt_sgmE[j] );
						 }
						 for (int i = 0; i < NCases; i++)
							 sgmT0[i] *= scale_sgm( r_acpt_T[i] );

						 delete mcmc;
				 }

				 /********************************************************

									Main step of MCMC

				 ********************************************************/

				 nmcmc = 4;

				 fout->WriteLine();
				 fout->WriteLine("----------------- Main MCMC ----------------------");
				 fout->WriteLine();

				 array<MCMC ^> ^ myMCMC = gcnew array<MCMC ^>(nmcmc);
				 for (int i = 0; i < nmcmc; i++){
					myMCMC[i] = gcnew MCMC();
					myMCMC[i]->Init( nmcmc, i, M, NCases, NSimu, data );
					myMCMC[i]->msg = "Main MCMC-" + i.ToString() + " ... ";

						 for (int j = 0; j < M; j++){
							 myMCMC[i]->mu[0][j] = mu0[j];
							 myMCMC[i]->lmbd[0][j] = lmbd0[j];
							 myMCMC[i]->sgmE[0][j] = sgmE0[j];
							 myMCMC[i]->sgmMu[j] = sgmMu0[j];
							 myMCMC[i]->sgmLmbd[j] = sgmLmbd0[j];
							 myMCMC[i]->sgm_sgmE[j] = sgm_sgmE0[j];
						 }
						 for (int k = 0; k < NCases; k++){
							 myMCMC[i]->T[0][k] = T0[k];
							 myMCMC[i]->sgmT[k] = sgmT0[k];
						 }
				 }

				 array<ThreadStart ^> ^ ThStart = gcnew array<ThreadStart ^>(nmcmc);
				 for (int i = 0; i < nmcmc; i++)
					 ThStart[i] = gcnew ThreadStart( myMCMC[i], &MCMC::do_mcmc );
				 array<Thread ^> ^ myThread = gcnew array<Thread ^>(nmcmc);
				 for (int i = 0; i < nmcmc; i++)
					 myThread[i] = gcnew Thread( ThStart[i] );
				 for (int i = 0; i < nmcmc; i++)
					 myThread[i]->Start();

				 for (int i = 0; i < nmcmc; i++)
					 myThread[i]->Join();

				 param_mu = new double*[M];
				 param_lmbd = new double*[M];
				 param_sgmE = new double*[M];
				 for (int i = 0; i < M; i++){
					param_mu[i] = new double[nmcmc * NSimu];
					param_lmbd[i] = new double[nmcmc * NSimu];
					param_sgmE[i] = new double[nmcmc * NSimu];
				 }

				 int * gacpt_mu = new int[M], * gacpt_lmbd = new int[M], * gacpt_sgmE = new int[M];
				 for (int i = 0; i < M; i++)
					 gacpt_mu[i] = gacpt_lmbd[i] = gacpt_sgmE[i] = 0;

				 int * gacpt_T = new int[NCases];
				 for (int i = 0; i < NCases; i++)
					 gacpt_T[i] = 0;

				 for (int imcmc = 0; imcmc < nmcmc; imcmc++){
					 for (int j = 0; j < M; j++){
						 gacpt_mu[j] += myMCMC[imcmc]->acpt_mu[j];
						 gacpt_lmbd[j] += myMCMC[imcmc]->acpt_lmbd[j];
						 gacpt_sgmE[j] += myMCMC[imcmc]->acpt_sgmE[j];

						 for (int k = 0; k < NSimu; k++){
							 param_mu[j][k + imcmc * NSimu] = myMCMC[imcmc]->mu[k + 1][j];
							 param_lmbd[j][k + imcmc * NSimu] = myMCMC[imcmc]->lmbd[k + 1][j];
							 param_sgmE[j][k + imcmc * NSimu] = myMCMC[imcmc]->sgmE[k + 1][j];
						 }
					 }
					 for (int i = 0; i < NCases; i++)
						 gacpt_T[i] += myMCMC[imcmc]->acpt_T[i];
				 }

				 for (int j = 0; j < M; j++)
					 fout->WriteLine("r_acpt_mu[" + j.ToString() + "] = " + (gacpt_mu[j] / double(nmcmc * NSimu)).ToString("F5"));
				 for (int j = 0; j < M; j++)
					 fout->WriteLine("r_acpt_lmbd[" + j.ToString() + "] = " + (gacpt_lmbd[j] / double(nmcmc * NSimu)).ToString("F5"));
				 for (int j = 0; j < M; j++)
					 fout->WriteLine("r_acpt_sgmE[" + j.ToString() + "] = " + (gacpt_sgmE[j] / double(nmcmc * NSimu)).ToString("F5"));
				 for (int i = 0; i < NCases; i++)
					 if ((i < 20) || (i > NCases - 20))
						 fout->WriteLine("r_acpt_T[" + i.ToString() + "] = " + (gacpt_T[i] / double(nmcmc * NSimu)).ToString("F5"));

				 omega = new double[nmcmc * NSimu];
				 for (int i = 0; i < nmcmc * NSimu; i++){
					double sum_lmbd = 0.0, sum_e2 = 0.0;
					for (int j = 0; j < M; j++){
						sum_lmbd += param_lmbd[j][i];
						sum_e2 += sqr(param_sgmE[j][i]);
					}
					omega[i] = sqr(sum_lmbd) / (sqr(sum_lmbd) + sum_e2);
				 }

				 double vsum = 0.0;
				 for (int i = 0; i < nmcmc * NSimu; i++)
					 vsum += omega[i];
				 double mean_omega = vsum / double(nmcmc * NSimu);
				 fout->WriteLine();
				 fout->WriteLine("Mean omega = " + mean_omega.ToString("F5"));

				 DispPost ^ cf = gcnew DispPost();
				 cf->DrawPosteriors( this, fout, M, nmcmc, NSimu );
			 }
	private: System::Void Form1_FormClosing(System::Object^  sender, System::Windows::Forms::FormClosingEventArgs^  e) {
				 if (fout != nullptr){
					 fout->Close();
					 MessageBox::Show(saveFileDialog1->FileName + " was saved.");
				 }
			 }
};
}

