#ifndef COMMON_CK
#define COMMON_CK

#include "myEigen.h"

using namespace myLib;

namespace cmmn {

		//
		//			omega_a = sqr(sum_lambda) / var(Y):						 	 (6.20a)
		//			omega_b = sqr(sum_lambda) / (sqr(sum_lambda) + sum(psi**2)): (6.20b)
		//
		void CalcOmega_ab( double & omega_a, double & omega_b, double ** sjk, int M, double * Lambda, double & GFI, double * psi2, System::IO::StreamWriter ^ fout );

}

#endif
